diff a/src/hotspot/share/gc/shenandoah/shenandoahForwarding.hpp b/src/hotspot/share/gc/shenandoah/shenandoahForwarding.hpp
--- a/src/hotspot/share/gc/shenandoah/shenandoahForwarding.hpp
+++ b/src/hotspot/share/gc/shenandoah/shenandoahForwarding.hpp
@@ -27,10 +27,13 @@
 
 #include "oops/oop.hpp"
 #include "utilities/globalDefinitions.hpp"
 
 class ShenandoahForwarding {
+private:
+  static const uintptr_t FWDED_HASH_TRANSITION = 0b111;
+
 public:
   /* Gets forwardee from the given object.
    */
   static inline oop get_forwardee(oop obj);
 
@@ -49,10 +52,11 @@
 
   /**
    * Returns true if the object is forwarded, false otherwise.
    */
   static inline bool is_forwarded(oop obj);
+  static inline bool is_forwarded(markWord m);
 
   /* Tries to atomically update forwardee in $holder object to $update.
    * Assumes $holder points at itself.
    * Asserts $holder is in from-space.
    * Asserts $update is in to-space.
